var aDelMediaServerID = [];
var aDelSipControllerID = [];
var aDelSipControllerServer = [];
var aDelTransID = [];

$(document).ready( function () {
	get_media_server();
	get_sip_controller();

	var tab = $('table[type=sip_controller]');
	$(tab).each(function(index,value) {
		var idx = value.getAttribute("idx");
		var conid = value.getAttribute("block_sip_controller_id");
		get_sip_controller_server(idx,conid);
	});
	
	get_sip_ip_transport();
});

function get_media_server(){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_media_server'
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			//alert(data[0]['name']);
			$.each(data, function (index, value) {
				addMediaServer(value);
			});
			
			result = data;
		},
		error:function(){
			alert('error: get_media_server');
		}
	});
	
	return result;
}

function get_sip_controller(){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_sip_controller'
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			//alert(data[0]['name']);
			$.each(data, function (index, value) {
				addSipController(value);
			});
			
			result = data;
		},
		error:function(){
			alert('error: get_sip_controller');
		}
	});
	
	return result;
}

function get_sip_controller_server(idx,conid){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_sip_controller_server',
			sip_controller_id:conid
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			$.each(data, function (index, value) {
				if(data[0]['media_server_id']!=null)
				addControllerServer(idx,conid,value);
			});
			
			result = data;
		},
		error:function(){
			alert('error: get_sip_controller_server');
		}
	});
	
	return result;
}

function get_sip_ip_transport(){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_sip_ip_transport'
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			//alert(data[0]['name']);
			$.each(data, function (index, value) {
				addSipIpTransport(value);
			});
			
			result = data;
		},
		error:function(){
			alert('error: get_sip_ip_transport');
		}
	});
	
	return result;
}





function addMediaServer(value){
	var container = $('td[id=media_server_container]')[0];
	document.getElementById("hidMediaServerCount").value++;
	var idx = document.getElementById("hidMediaServerCount").value;
	
	/*
	var blocks = $('table[type=media_server]');
	var block_count = 0;
	if(blocks.length > 0) block_count = blocks.length; 
	block_count++;
	*/
	
	if(!value || value==null){
		value = {
			"id": "", 
			"name": "", 
			"ip": "", 
			"port": ""
		};
	}

	var tab = document.createElement("table");
	tab.className = "dataBlock_light";
	tab.setAttribute("type","media_server");
	tab.setAttribute("idx",idx);
	tab.setAttribute("block_media_server_id",value["id"]);

	tab.onclick = function() {
		var blocks = $('table[type=media_server]');
		$(blocks).each(function( index ) {
		  if(this != tab) {
			  this.className = "dataBlock_light";
			  var block_header = $('tr[type=trMediaServerHeader]',this)[0];
			  $(block_header).css("backgroundColor","#f5f5f5");
		  }

		  tab.className = "dataBlock_dark";
		  var block_header = $('tr[type=trMediaServerHeader]',tab)[0];
		  $(block_header).css("backgroundColor","#ccc");
		  
		});
	};


	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","trMediaServerHeader");
	var td = document.createElement("td");
	td.colSpan = 2;
	td.className = "editTableHeader";
	td.innerHTML = "<div style=\"display:inline;float:left\">&nbsp; Media Server #"+idx+"&nbsp;</div>"+
	"<img class=\"imglink\" style=\"display:inline;float:right;margin-right:2px;\" onclick=\"delMediaServer(this);\" title=\"Delete Media Server\" src=\"../inc/img/del.gif\">";
	tr.appendChild(td);
	tab.appendChild(tr);


	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"id";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edMediaServer_id_"+idx+"\" id=\"edMediaServer_id_"+idx+"\" type=\"text\" value=\""+value["id"]+"\" class=\"selectw\" disabled=\"true\" >";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"name";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edMediaServer_name_"+idx+"\" id=\"edMediaServer_name_"+idx+"\" type=\"text\" value=\""+value["name"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"ip";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edMediaServer_ip_"+idx+"\" id=\"edMediaServer_ip_"+idx+"\" type=\"text\" value=\""+value["ip"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

/*
	var field_value = value["port"];
	AddTableRow(tab, "port", 
	'<input id=edMediaServer_port_'+idx+' type="text" class=' + getInputClass(field_value) + ' style="" value="' + field_value + '" \
	oninput="debounceEdtDBOption(this)" onfocus="inputTableCellNullFocus(this);" onblur="setTimeout(inputTableCellNullBlur,50,this);" /> \
	<input type="checkbox" class=' + getCheckboxClass(field_value) + ' \
	onchange="checkTableCellNullSet(this);" onblur="setTimeout(checkTableCellNullBlur,50,this);" />'
	);
*/
	var field_value = value["port"];
	AddTableRow(tab, "port", 
	'<input id=edMediaServer_port_'+idx+' type="text" class=' + getInputClass(field_value) + ' style="" value="' + field_value + '" \
	onfocus="inputTableCellNullFocus(this);" onblur="setTimeout(inputTableCellNullBlur,50,this);" /> \
	<input type="checkbox" class=' + getCheckboxClass(field_value) + ' \
	onchange="checkTableCellNullSet(this);" onblur="setTimeout(checkTableCellNullBlur,50,this);" />'
	);

	container.appendChild(tab);
	
}

function delMediaServer(obj){
	obj.parentElement.parentElement.parentElement.remove();
	var obj_id = obj.parentElement.parentElement.parentElement.getAttribute('block_media_server_id');
	aDelMediaServerID.push(obj_id);
}

function addSipController(value){
	var container = $('td[id=sip_controller_container]')[0];
	document.getElementById("hidSipControllerCount").value++;
	var idx = document.getElementById("hidSipControllerCount").value;

	if(!value || value==null){
		value = {
			"id": "", 
			"name": ""
		};
	}

	var tab = document.createElement("table");
	tab.className = "dataBlock_light";
	tab.setAttribute("type","sip_controller");
	tab.setAttribute("idx",idx);
	tab.setAttribute("block_sip_controller_id",value["id"]);
	//tab.style = "inline-block;";
	//tab.setAttribute("style", "display: inline-block; flex-wrap: wrap");
	//tab.setAttribute("style", "display: flex; flex-wrap: initial");
	//tab.setAttribute("style", "flex-flow: column nowrap;");
	//tab.setAttribute("style", "clear:left; display:inline;");
	tab.setAttribute("style", "display:block;");
	

	tab.onclick = function() {
		var blocks = $('table[type=sip_controller]');
		$(blocks).each(function( index ) {
		  if(this != tab) {
			  this.className = "dataBlock_light";
			  var block_header = $('tr[type=trSipControllerHeader]',this)[0];
			  $(block_header).css("backgroundColor","#f5f5f5");
		  }

		  tab.className = "dataBlock_dark";
		  var block_header = $('tr[type=trSipControllerHeader]',tab)[0];
		  $(block_header).css("backgroundColor","#ccc");
		  
		});
	};


	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","trSipControllerHeader");
	var td = document.createElement("td");
	td.colSpan = 2;
	td.className = "editTableHeader";
	td.innerHTML = "<div style=\"display:inline;float:left\">&nbsp; Sip Controller #"+idx+"&nbsp;</div>"+
	"<img class=\"imglink\" style=\"display:inline;float:right;margin-right:2px;\" onclick=\"delSipController(this);\" title=\"Delete Sip Controller\" src=\"../inc/img/del.gif\">";
	tr.appendChild(td);
	tab.appendChild(tr);


	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"id";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edSipController_id_"+idx+"\" id=\"edSipController_id_"+idx+"\" type=\"text\" value=\""+value["id"]+"\" class=\"selectw\" disabled=\"true\" >";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"name";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edSipController_name_"+idx+"\" id=\"edSipController_name_"+idx+"\" type=\"text\" value=\""+value["name"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	var tr = document.createElement("tr");
	var td = document.createElement("td");
	td.className = "editLineParamTop";
	var conid = (typeof value["id"] === 'number') ? value["id"] : null;
	td.innerHTML = "media server"+
	"<img class=\"imglink\" style=\"display:inline;float:right; margin-top: 2px;\" onclick=\"addControllerServer("+idx+","+conid+",null);\" title=\"Add Media Server\" src=\"../inc/img/add.gif\">";
	tr.appendChild(td);
	var td = document.createElement("td");
	td.innerHTML = "<table id=Controller_Server_"+idx+">"+
	"<tr><td nowrap>media server</td><td nowrap>rtp port start</td><td nowrap>rtp port count</td><td>&nbsp;</td></tr>"+
	"</table>";
	tr.appendChild(td);
	tab.appendChild(tr);

	container.appendChild(tab);

}


function addControllerServer(idx,conid,value){
	var tab = $('table[id=Controller_Server_'+idx+']')[0];
	
	//var sip_controller_id = $(tab)block_sip_controller_id
	var sip_controller_id = null;
	//document.getElementById("hidSipControllerCount").value++;
	//var idx = document.getElementById("hidSipControllerCount").value;
	
	if(!value || value==null){
		value = {
			"media_server_id": "", 
			"media_server_name": "", 
			"rtp_port_start" : "",
			"rtp_port_count" : ""
		};
	}

	//var tab = document.createElement("table");
	//tab.className = "dataBlock_light";
	//tab.setAttribute("type","sip_controller");
	//tab.setAttribute("idx",idx);
	//tab.setAttribute("block_sip_controller_id",value["id"]);
/*
	tab.onclick = function() {
		var blocks = $('table[type=sip_controller]');
		$(blocks).each(function( index ) {
		  if(this != tab) {
			  this.className = "dataBlock_light";
			  var block_header = $('tr[type=trSipControllerHeader]',this)[0];
			  $(block_header).css("backgroundColor","#f5f5f5");
		  }

		  tab.className = "dataBlock_dark";
		  var block_header = $('tr[type=trSipControllerHeader]',tab)[0];
		  $(block_header).css("backgroundColor","#ccc");
		  
		});
	};
*/

	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","sip_controller_server");

	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML = "<select name=\"edSipController_server_"+idx+"\" id=\"edSipController_server_"+idx+"\" class=\"selectw\" >"+
					doMediaServerOption(value["media_server_id"])+
					"</select>\n";
	tr.appendChild(td);

	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edSipController_portstart_"+idx+"\" id=\"edSipController_portstart_"+idx+"\" type=\"text\" value=\""+value["rtp_port_start"]+"\" class=\"selectw70\">";
	tr.appendChild(td);

	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edSipController_portcount_"+idx+"\" id=\"edSipController_portcount_"+idx+"\" type=\"text\" value=\""+value["rtp_port_count"]+"\" class=\"selectw70\">";
	tr.appendChild(td);

	var td = document.createElement("td");
	td.innerHTML = "<img class=\"imglink\" style=\"display:inline;float:right;\" onclick=\"delControllerServer(this,"+conid+","+value['media_server_id']+");\" title=\"Delete Controller Server\" src=\"../inc/img/del.gif\">";
	tr.appendChild(td);

	tab.appendChild(tr);

}

function delControllerServer(obj,sip_controller_id,media_server_id){
	//if(sip_controller_id>=0 && media_server_id>=0) aDelSipControllerServer.push(['media_server_id' => sip_controller_id, 'media_server_id' => media_server_id]);
	if(sip_controller_id>=0 && media_server_id>=0) aDelSipControllerServer.push([sip_controller_id,media_server_id]);
	obj.parentElement.parentElement.remove();
}




function doMediaServerOption(opid){
	var res = '';
	var blocks = $('table[type=media_server]');
	$(blocks).each(function(index,value) {
		var idx = value.getAttribute("idx");
		var id = document.getElementById("edMediaServer_id_"+idx).value;
		var name = document.getElementById("edMediaServer_name_"+idx).value;
		var sel = GetSelectedString(opid,id);
		res += "<option value=\""+id+"\" "+sel+">"+name+" ["+id+"]</option>"
	});
	return res;
}

function delSipController(obj){
	obj.parentElement.parentElement.parentElement.remove();
	var obj_id = obj.parentElement.parentElement.parentElement.getAttribute('block_sip_controller_id');
	aDelSipControllerID.push(obj_id);
}


function addSipIpTransport(value){
	var container = $('td[id=sip_ip_transport_container]')[0];

	document.getElementById("hidSipIpTransportCount").value++;
	// idx - unique block number on page, not id of transport in the database
	var idx = document.getElementById("hidSipIpTransportCount").value;
	
	/*
	var blocks = $('table[type=sip_ip_transport]');
	var block_count = 0;
	if(blocks.length > 0) block_count = blocks.length; 
	block_count++;
	*/
	
	if(!value || value==null){
		value = {
			"id": "", 
			"protocol": "", 
			"ip": "", 
			"port": "", 
			"name": "", 
			"cert_file": "", 
			"key_file": "", 
			"is_ip_v6": "",
			"sip_controller_id": ""
		};
	}

	var tab = document.createElement("table");
	tab.className = "dataBlock_light";
	tab.setAttribute("type","sip_ip_transport");
	tab.setAttribute("idx",idx);
	tab.setAttribute("block_trans_id",value["id"]);

	tab.onclick = function() {
		var blocks = $('table[type=sip_ip_transport]');
		$(blocks).each(function( index ) {
		  if(this != tab) {
			  this.className = "dataBlock_light";
			  var block_header = $('tr[type=trTransportHeader]',this)[0];
			  $(block_header).css("backgroundColor","#f5f5f5");
		  }

		  tab.className = "dataBlock_dark";
		  var block_header = $('tr[type=trTransportHeader]',tab)[0];
		  $(block_header).css("backgroundColor","#ccc");
		  
		});
	};


	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","trTransportHeader");
	var td = document.createElement("td");
	td.colSpan = 2;
	td.className = "editTableHeader";
	td.innerHTML = "<div style=\"display:inline;float:left\">&nbsp; Transport #"+idx+"&nbsp;</div>"+
	"<img class=\"imglink\" style=\"display:inline;float:right;margin-right:2px;\" onclick=\"delSipIpTransport(this);\" title=\"Delete Transport\" src=\"../inc/img/del.gif\">";
	tr.appendChild(td);
	tab.appendChild(tr);


	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"id";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edTrans_id_"+idx+"\" id=\"edTrans_id_"+idx+"\" type=\"text\" value=\""+value["id"]+"\" class=\"selectw\" disabled=\"true\" >";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"protocol";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	//td.innerHTML =	"<input name=\"edTrans_protocol_"+idx+"\" id=\"edTrans_protocol_"+idx+"\" type=\"text\" value=\""+value["protocol"]+"\" class=\"selectw\">";
	td.innerHTML = "<select name=\"edTrans_protocol_"+idx+"\" id=\"edTrans_protocol_"+idx+"\" class=\"selectw\" onchange=\"onTransChangeProtocol("+idx+")\" >"+
					"<option value=\"tcp\" "+GetSelectedString(value["protocol"], "tcp")+">tcp</option>"+
					"<option value=\"udp\" "+GetSelectedString(value["protocol"], "udp")+">udp</option>\n"+
					"</select>\n";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"ip";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edTrans_ip_"+idx+"\" id=\"edTrans_ip_"+idx+"\" type=\"text\" value=\""+value["ip"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"port";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edTrans_port_"+idx+"\" id=\"edTrans_port_"+idx+"\" type=\"text\" value=\""+value["port"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"name";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edTrans_name_"+idx+"\" id=\"edTrans_name_"+idx+"\" type=\"text\" value=\""+value["name"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"cert_file";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edTrans_cert_file_"+idx+"\" id=\"edTrans_cert_file_"+idx+"\" type=\"text\" value=\""+value["cert_file"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"key_file";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edTrans_key_file_"+idx+"\" id=\"edTrans_key_file_"+idx+"\" type=\"text\" value=\""+value["key_file"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"is_ip_v6";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edTrans_is_ip_v6_"+idx+"\" id=\"edTrans_is_ip_v6_"+idx+"\" type=\"text\" value=\""+value["is_ip_v6"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	var opstr = getControllerList(value["sip_controller_id"]);
	AddTableRow(tab, "sip_controller",
		"<select name=\"edTrans_sip_controller_"+idx+"\" " +
		"id=\"edTrans_sip_controller_"+idx+"\" " +
		"class=\"selectw\">" + 
		opstr + 
		"</select>\n");

	container.appendChild(tab);
	
	if(value["port"] == "" && value["ip"] == "") onTransChangeProtocol(idx);
}

function delSipIpTransport(obj){
	obj.parentElement.parentElement.parentElement.remove();
	var obj_id = obj.parentElement.parentElement.parentElement.getAttribute('block_trans_id');
	aDelTransID.push(obj_id);
}


function getControllerList(conid){
	var con = $('table[type=sip_controller]');
	var res = "<option value='null' ></option>";
	$(con).each(function(index,value) {
		var idx = value.getAttribute("idx");
		var sip_controller_id = document.getElementById("edSipController_id_"+idx).value;
		var ip_controller_name = document.getElementById("edSipController_name_"+idx).value;
		res += "<option value="+sip_controller_id+" "+GetSelectedString(sip_controller_id, conid)+">"+ip_controller_name+"</option>";
	});
	return res;
}


/*
// дебонсинг события редактирования
function debounce(func, wait, immediate) {
	var timeout;
	return function() {
		var context = this, args = arguments;
		clearTimeout(timeout);
		timeout = setTimeout(function() {
			timeout = null;
			if (!immediate) func.apply(context, args);
		}, wait);
		if (immediate && !timeout) func.apply(context, args);
	};
}

var debounceEdtDBOption = debounce(function(obj){
	EdtDBOption(obj);
}, 250);

function EdtDBOption(obj){
	var row_obj = obj.parentElement.parentElement;
	var row_id = row_obj.getAttribute('row_id');
	//obj.style.backgroundColor = "#ff8080";
	var row_mode_obj = $('td[id=rowmode_'+row_id+']',row_obj)[0];
	var row_mode = $('td[id=rowmode_'+row_id+']',row_obj)[0].innerHTML;
	if(row_mode != "a") {
		$(row_obj).children('td').children('input').css("backgroundColor","#ffc4c4");
		if(row_mode == "d" || row_mode == "ed") row_mode_obj.innerHTML = "ed";
		else row_mode_obj.innerHTML = "e";
	}
}
*/

function onSaveClick(){

	var blocks = $('table[type=media_server]');
	$(blocks).each(function(index,value) {
		var idx = value.getAttribute("idx");
		var id = document.getElementById("edMediaServer_id_"+idx).value;
		var name = document.getElementById("edMediaServer_name_"+idx).value;
		var ip = document.getElementById("edMediaServer_ip_"+idx).value;
		var port = document.getElementById("edMediaServer_port_"+idx).value;
		//alert(id+' '+name+' '+ip+' '+port);
		
		save_media_server(id,name,ip,port);
	});

/*
	var blocks = $('table[type=sip_controller]');
	$(blocks).each(function(index,value) {
		var idx = value.getAttribute("idx");
		var id = document.getElementById("edSipController_id_"+idx).value;
		var name = document.getElementById("edSipController_name_"+idx).value;
		save_sip_controller(id,name);
	});

	var tab = $('table[type=sip_controller]');
	$(tab).each(function(index,value) {
		var idx = value.getAttribute("idx");
		var sip_controller_id = value.getAttribute("block_sip_controller_id");
		var serv = $('tr[type=sip_controller_server]',this);
		$(serv).each(function(index,value) {
			var media_server_id = $(this).find("td:eq(0) select[id='edSipController_server_"+idx+"']").val();
			var rtp_port_start = $(this).find("td:eq(1) input[id='edSipController_portstart_"+idx+"']").val();
			var rtp_port_count = $(this).find("td:eq(2) input[id='edSipController_portcount_"+idx+"']").val();
			//alert(idx+' '+index+' '+sip_controller_id+' '+media_server_id+' '+rtp_port_start+' '+rtp_port_count);
			save_sip_controller_server(sip_controller_id,media_server_id,rtp_port_start,rtp_port_count);
		});
	});
*/

	var blocks = $('table[type=sip_controller]');
	$(blocks).each(function(index,value) {
		var idx = value.getAttribute("idx");
		var sip_controller_id = document.getElementById("edSipController_id_"+idx).value;
		var ip_controller_name = document.getElementById("edSipController_name_"+idx).value;
		var con = save_sip_controller(sip_controller_id,ip_controller_name);
		//alert(con[0]['id']);
		sip_controller_id = con[0]['id'];
		var serv = $('tr[type=sip_controller_server]',this);
		$(serv).each(function(serv_index,serv_value) {
			var media_server_id = $(this).find("td:eq(0) select[id='edSipController_server_"+idx+"']").val();
			var rtp_port_start = $(this).find("td:eq(1) input[id='edSipController_portstart_"+idx+"']").val();
			var rtp_port_count = $(this).find("td:eq(2) input[id='edSipController_portcount_"+idx+"']").val();
			//alert(idx+' '+serv_index+' '+sip_controller_id+' '+media_server_id+' '+rtp_port_start+' '+rtp_port_count);
			save_sip_controller_server(sip_controller_id,media_server_id,rtp_port_start,rtp_port_count);
		});
	});




	var blocks = $('table[type=sip_ip_transport]');
	$(blocks).each(function(index,value) {
		var idx = value.getAttribute("idx");
		var id = document.getElementById("edTrans_id_"+idx).value;
		var protocol = document.getElementById("edTrans_protocol_"+idx).value;
		var ip = document.getElementById("edTrans_ip_"+idx).value;
		var port = document.getElementById("edTrans_port_"+idx).value;
		var name = document.getElementById("edTrans_name_"+idx).value;
		var cert_file = document.getElementById("edTrans_cert_file_"+idx).value;
		var key_file = document.getElementById("edTrans_key_file_"+idx).value;
		var is_ip_v6 = document.getElementById("edTrans_is_ip_v6_"+idx).value;
		var sip_controller_id = document.getElementById("edTrans_sip_controller_"+idx).value;

		//if(!port || port==null || port=='null') port = "";
		//if(!is_ip_v6 || is_ip_v6==null || is_ip_v6=='null') is_ip_v6 = "";
		//alert(sip_controller_id);
		
		save_sip_ip_transport(id,protocol,ip,port,name,cert_file,key_file,is_ip_v6,sip_controller_id);
	});
	
	$(aDelTransID).each(function(index,value){
		del_sip_ip_transport(value);
	});

	$(aDelSipControllerID).each(function(index,value){
		del_sip_controller(value);
	});

	$(aDelSipControllerServer).each(function(index,value){
		del_sip_controller_server(value[0],value[1]);
	});

	$(aDelMediaServerID).each(function(index,value){
		del_media_server(value);
	});


	/*
	$('tr[type=optionrow]').each(function( index ) {
		//alert(index);
		//var obj = $(this).children('td').children('input')
		//var option_name = obj[0].value;
		var row_id = $(this).attr('row_id');
		
		var option_name = $('input[col_id=option_name][row_id='+row_id+']','td', this)[0].value;
		var int_value = $('input[col_id=int_value][row_id='+row_id+']','td', this)[0].value;
		var str_value = $('input[col_id=str_value][row_id='+row_id+']','td', this)[0].value;
		var date_value = $('input[col_id=date_value][row_id='+row_id+']','td', this)[0].value;
		var float_value = $('input[col_id=float_value][row_id='+row_id+']','td', this)[0].value;
		var description = $('input[col_id=description][row_id='+row_id+']','td', this)[0].value;
		var param_type = $('input[col_id=param_type][row_id='+row_id+']','td', this)[0].value;
		var param_name = $('input[col_id=param_name][row_id='+row_id+']','td', this)[0].value;
		
		var rowmode = $('td[id=rowmode_'+row_id+']',this)[0].innerHTML;
		//if(rowmode != '') alert(rowmode+' '+option_name);


		if(!int_value || int_value==null || int_value=='null') int_value = "";
		//if(!str_value || str_value==null || str_value=='null') str_value = "";
		if(!date_value || date_value==null || date_value=='null') date_value = "";
		if(!float_value || float_value==null || float_value=='null') float_value = "";
		//if(!description || description==null || description=='null') description = "";
		if(!param_type || int_value==null || param_type=='null') param_type = "";
		if(!param_name || param_name==null || param_name=='null') param_name = "";

		
		save_db_options(option_name, int_value, str_value, date_value, float_value, description, param_type, param_name, rowmode);
		
	});
	*/
}

function save_media_server(id,name,ip,port){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'save_media_server',
			id: id,
			name: name,
			ip: ip,
			port: port
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			//alert(data[0]['id']);
		},
		error:function(){
			alert('error: save_media_server');
		}
	});
}

function del_media_server(id){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'del_media_server',
			id: id
		}),
		dataType: 'json',
		async: false,
		timeout: 10000,
		success: function(data) {
			//alert(data[0]['result']);
		},
		error:function(){
			alert('error: del_media_server');
		}
	});
}

function save_sip_controller(id,name){
	var result = false;
	//alert(id+' '+name);
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'save_sip_controller',
			id: id,
			name: name
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			//alert(data[0]['result']);
			result = data;
		},
		error:function(){
			alert('error: save_sip_controller');
		}
	});
	return result;
}

function del_sip_controller(id){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'del_sip_controller',
			id: id
		}),
		dataType: 'json',
		async: false,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: del_sip_controller');
		}
	});
}



function save_sip_controller_server(sip_controller_id,media_server_id,rtp_port_start,rtp_port_count){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'save_sip_controller_server',
			sip_controller_id: sip_controller_id,
			media_server_id: media_server_id,
			rtp_port_start: rtp_port_start,
			rtp_port_count: rtp_port_count
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: save_sip_controller_server');
		}
	});
}

function del_sip_controller_server(sip_controller_id,media_server_id){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'del_sip_controller_server',
			sip_controller_id: sip_controller_id,
			media_server_id, media_server_id
		}),
		dataType: 'json',
		async: false,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: del_sip_controller_server');
		}
	});
}




function save_sip_ip_transport(id,protocol,ip,port,name,cert_file,key_file,is_ip_v6,sip_controller_id){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'save_sip_ip_transport',
			id: id,
			protocol: protocol,
			ip: ip,
			port: port,
			name: name,
			cert_file: cert_file,
			key_file: key_file,
			is_ip_v6: is_ip_v6,
			sip_controller_id: sip_controller_id
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: save_sip_ip_transport');
		}
	});
}


function del_sip_ip_transport(id){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'del_sip_ip_transport',
			id: id
		}),
		dataType: 'json',
		async: false,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: del_sip_ip_transport');
		}
	});
}

function onTransChangeProtocol(idx){
	var protocol = document.getElementById("edTrans_protocol_"+idx).value;
	var port = document.getElementById("edTrans_port_"+idx);
	//if(port.value==""){
		if(protocol=="tcp") port.value = "5061";
		if(protocol=="udp") port.value = "5060";
	//}
}